#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define ll long long
#define pb push_back
#define sz(x) (int)(x).size()
#define mp make_pair
#define f first
#define s second
#define all(x) x.begin(), x.end()
#define D(x) cerr << #x << " is " << (x) << "\n";

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,tree_order_statistics_node_update>; ///find_by_order(),order_of_key()
template<class T1, class T2> ostream& operator<<(ostream& os, const pair<T1,T2>& a) { os << '{' << a.f << ", " << a.s << '}'; return os; }
template<class T> ostream& operator<<(ostream& os, const vector<T>& a){os << '{';for(int i=0;i<sz(a);i++){if(i>0&&i<sz(a))os << ", ";os << a[i];}os<<'}';return os;}
template<class T> ostream& operator<<(ostream& os, const set<T>& a) {os << '{';int i=0;for(auto p:a){if(i>0&&i<sz(a))os << ", ";os << p;i++;}os << '}';return os;}
template<class T> ostream& operator<<(ostream& os, const multiset<T>& a) {os << '{';int i=0;for(auto p:a){if(i>0&&i<sz(a))os << ", ";os << p;i++;}os << '}';return os;}
template<class T1,class T2> ostream& operator<<(ostream& os, const map<T1,T2>& a) {os << '{';int i=0;for(auto p:a){if(i>0&&i<sz(a))os << ", ";os << p;i++;}os << '}';return os;}
const long double EPS = (long double)1e-14;
struct PT
{
    long double x,y;
    long double length()
    {
        return sqrt(x*x+y*y);
    }
    int normalize()
    {
        long double l = length();
        if(fabs(l)<EPS)
            return -1;
        x/=l;
        y/=l;
        return 0;
    }
    PT operator-(PT a)
    {
        PT r;
        r.x=x-a.x;
        r.y=y-a.y;
        return r;
    }
    PT operator+(PT a)
    {
        PT r;
        r.x=x+a.x;
        r.y=y+a.y;
        return r;
    }
    PT operator*(long double sc)
    {
        PT r;
        r.x=x*sc;
        r.y=y*sc;
        return r;
    }
    friend ostream& operator<<(ostream& out,PT p)
    {
        out << "{" << p.x << "," << p.y << "}";
        return out;
    }
};

long double dist(PT& a, PT& b)
/// the distance between two points
{
    return (long double)sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}

long double trap(PT a, PT b)
{
    return (0.5*(b.x - a.x)*(b.y + a.y));
}
long double triarea(PT a, PT b, PT c)
{
    return fabs(trap(a,b)+trap(b,c)+trap(c,a));
}
void closestpt( PT p1, PT p2, PT p3, PT &r )
{
    if( fabs( triarea( p1, p2, p3 ) ) < EPS )
    {
        r = p3;
        return;
    }
    PT v = p2-p1;
    v.normalize();
    long double pr;
    pr = (p3.y-p1.y)*v.y + (p3.x-p1.x)*v.x;
    r = p1+v*pr;
}
int lineAndCircle(PT& oo, long double r, PT& p1, PT& p2)
/// returns -1 if there is no intersection
/// returns 1 if there is only one intersection
{
    PT m;
    closestpt(p1,p2,oo,m);
    PT v = p2-p1;
    v.normalize();
    long double r0=dist(oo, m);
    if(r0>r+EPS)
        return 0;
    return 1;
}
vector<pair<PT,int> > qu;
vector<int> sol;
void solve(int l,int r,vector<pair<PT,PT> > lines,int yes)
{
    if(r-l==1)
        return;
    int m=(l+r)>>1;
    sol[m]+=yes;
    int n=lines.size();
    vector<int> sece(n);
    for(int i=0;i<n;i++)
    {
        if(lineAndCircle(qu[m].f,qu[m].s,lines[i].f,lines[i].s))
            sece[i]=1,sol[m]++;
    }
    int done=0;
    vector<pair<PT,PT> > levo,desno;
    for(int i=0;i<n;i++)
    {
        if(sece[i])
        {
            levo.pb(lines[i]);
            done++;
        }
        else
        {
            desno.pb(lines[i]);
        }
    }
    solve(l,m,levo,yes);
    solve(m,r,desno,yes+done);
}
int main()
{
    int n;
    scanf("%i",&n);
    vector<pair<PT,PT> > lines;
    for(int i=0;i<n;i++)
    {
        int x,y,a,b;
        scanf("%i %i %i %i",&x,&y,&a,&b);
        PT p1,p2;
        p1.x=x;p1.y=y;p2.x=a;p2.y=b;
        lines.pb({p1,p2});
    }
    int q;
    scanf("%i",&q);
    sol.resize(q);
    if(n==0)
    {
        for(int i=0;i<q;i++)
        {
            printf("0\n");
            return 0;
        }
    }
    for(int i=0;i<q;i++)
    {
        int x,y,r;
        scanf("%i %i %i",&x,&y,&r);
        PT p;
        p.x=x;p.y=y;
        qu.pb({p,r});
    }
    if(q==0)
        return 0;
    if(q==1)
    {
        int cnt=0;
        for(auto p:lines)
            if(lineAndCircle(qu[0].f,qu[0].s,p.f,p.s))
                cnt++;
        printf("%i\n",cnt);
        return 0;
    }
    vector<int> cnt(n);
    for(int i=0;i<n;i++)
    {
        if(lineAndCircle(qu[q-1].f,qu[q-1].s,lines[i].f,lines[i].s))
            cnt[i]++,sol[q-1]++;
        if(lineAndCircle(qu[0].f,qu[0].s,lines[i].f,lines[i].s))
            assert(cnt[i]),cnt[i]++,sol[0]++;
    }
    vector<pair<PT,PT> > doit;
    int done=0;
    for(int i=0;i<n;i++)
    {
        if(cnt[i]==2)
            done++;
        if(cnt[i]==1)
        {
            doit.pb(lines[i]);
        }
    }
    solve(0,q-1,doit,done);
    for(int i=0;i<q;i++)
        printf("%i\n",sol[i]);
    return 0;
}